/****************************************************/
/* 20sector DOS to file                             */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN		16
#define	SECLEN		0x400
#define	MAXSEC		5
#define	MAXTRACK	80
#define	FILEOFFSET	0x1400
#define	CLASTERSIZE	0x0a00
#define	CLOFFSET	0x2500

/*
track0x00:C=00 H=00 R=01 N=03=0x400 0x0002b0
track0x00:C=00 H=00 R=02 N=03=0x400 0x0006c0
track0x00:C=00 H=00 R=03 N=03=0x400 0x000ad0
track0x00:C=00 H=00 R=04 N=03=0x400 0x000ee0
track0x00:C=00 H=00 R=05 N=03=0x400 0x0012f0
track0x00:C=00 H=00 R=01 N=01=0x100 0x001700
:
track0x4F:C=27 H=01 R=01 N=03=0x400 0x069b50
track0x4F:C=27 H=01 R=02 N=03=0x400 0x069f60
track0x4F:C=27 H=01 R=03 N=03=0x400 0x06a370
track0x4F:C=27 H=01 R=04 N=03=0x400 0x06a780
track0x4F:C=27 H=01 R=05 N=03=0x400 0x06ab90
track0x4F:C=27 H=01 R=01 N=01=0x100 0x06afa0
*/

/*
PNX^POZN^i0x100~10j
PgbNQOZN^QNX^

C=XXAH=XXAR=01AN=01́ABASICł͎gpȂiu[gpj

NX^́A擪珇ԂɔԍU

gbN0x00NX^0x00ANX^0x01
gbN0x01NX^0x02ANX^0x03
gbN0x02NX^0x04ANX^0x05
 :

NX^0x02A0x03́ABASICVXeŎgpB
iFILELISTAFATj

*/


int main(int argc, char **argv)
{
	unsigned char	diskimg[MAXTRACK*MAXSEC*SECLEN];
	char	outbody[S_LEN],outext[S_LEN],outfile[S_LEN];
	FILE	*infp, *outfp;
	int		num,c,i,j,k;
	int		fileno,fileptr;
	int		flag;
	int		claster,clsize,nextcl;

	if (argc != 2) {
		fprintf(stderr, "Usage: d88file infile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	for (i = 0;i < 0x02b0;i ++) {
		if ((c = fgetc(infp)) == EOF) {
			printf("Data illigal\n");
			exit(1);
		}
	}

	for (i = 0;i < MAXTRACK;i ++) {
		for (j = 0;j < MAXSEC;j ++) {

			for (k = 0;k < 16;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
			}
			for (k = 0;k < SECLEN;k ++) {
				if ((c = fgetc(infp)) == EOF) {
					printf("Data illigal\n");
					exit(1);
				}
				diskimg[i*MAXSEC*SECLEN+j*SECLEN+k] = (unsigned char)c;
			}
		}

		/* UZN^ځiǂݔ΂j*/
		for (k = 0;k < 16;k ++) {
			if ((c = fgetc(infp)) == EOF) {
				printf("Data illigal\n");
				exit(1);
			}
		}
		for (k = 0;k < 0x100;k ++) {
			if ((c = fgetc(infp)) == EOF) {
				printf("Data illigal\n");
				exit(1);
			}
		}

	}


/* file generate */

	fileno = 0;

	for (;;) {
		fileptr = fileno * 0x10 + FILEOFFSET;
		c = diskimg[fileptr];
		flag = (0x21 <= c && c <= 0x7F) ? 1 : 0;
		if (c == 0xff) {
			break;
		}
		if (fileno == 0x40) {
			break;
		}
		if (flag == 0) {
			fileno ++;
			continue;
		}

		for (i = 0;i < 6;i ++) {
			outbody[i] = diskimg[fileptr + i];
		}
		for (i = 0;i < 3;i ++) {
			outext[i]  = diskimg[fileptr + 6 + i];
		}

		for (i = 0,j = 0;i < 6;i ++,j++) {
			c = (outbody[i] & 0x7F);
			if (c == 0x20) {
				break;
			}
			outfile[j] = c;
		}

		if (outext[0] != 0x20) {

			outfile[j] = '.';
			j ++;

			for (i = 0;i < 3;i ++,j++) {
				c = (outext[i] & 0x7F);
				if (c == 0x20) {
					break;
				}
				outfile[j] = c;
			}
		}
		outfile[j] = 0x00;
		printf("Generate file : %s\n",outfile);

		if ((outfp = fopen(outfile, "wb")) == NULL) {
			perror(outfile);
			exit(1);
		}

		claster = diskimg[fileptr + 10];

		for (;;) {

			nextcl = diskimg[claster + CLOFFSET];

			if (nextcl == 0xff || nextcl == 0xfe) {
				break;
			}

			/* NX^TCYZo */

			clsize = CLASTERSIZE;
			if ((nextcl & 0xf0) == 0xc0) {
				clsize = 0x100 * (nextcl & 0x0f);
			}

			for (i = 0;i < clsize;i ++ ) {
				fputc(diskimg[claster * CLASTERSIZE + i],outfp);
			}

			if ((nextcl & 0xf0) == 0xc0) {
				break;
			}
			claster = nextcl;
		}

		fclose(outfp);
		fileno ++;

	}


	fclose(infp);


	return(0);
}
